float q1 = 0;
float q2 = 0;
float q3 = 0;
float q4 = 1;


//-----------------------------------------------------------------------------
//
void ArsMahony(float wx, float wy, float wz, float ax, float ay, float az, float dt, float *phi, float *theta, float*psi)
{
  float norm;
  
  float gbx;
  float gby;
  float gbz;
  

  norm = sqrt(ax*ax + ay*ay + az*az);
  ax /= norm;
  ay /= norm;
  az /= norm;
 
  gbx = 2*(q1*q3 - q2*q4);               // g in body axes
  gby = 2*(q2*q3 + q4*q1);
  gbz = 1 - 2*(q1*q1 + q2*q2);

  wx -= 5*(ay*gbz - az*gby);
  wy -= 5*(az*gbx - ax*gbz);
  wz -= 5*(ax*gby - ay*gbx);

  q1 += 0.5*( q4*wx - q3*wy + q2*wz)*dt;
  q2 += 0.5*( q3*wx + q4*wy - q1*wz)*dt;
  q3 += 0.5*(-q2*wx + q1*wy + q4*wz)*dt;
  q4 += 0.5*(-q1*wx - q2*wy - q3*wz)*dt;

  norm = sqrt(q1*q1 + q2*q2 + q3*q3 + q4*q4);
  q1 /= norm;
  q2 /= norm;
  q3 /= norm;
  q4 /= norm;

  *phi   =  atan2(2*q2*q3 + 2*q1*q4, 1 - 2*(q1*q1 + q2*q2));
  *theta = -asin(2*q1*q3 - 2*q2*q4);
  *psi   =  atan2(2*q1*q2 + 2*q3*q4, 1 - 2*(q2*q2 + q3*q3));
}