#include <SPI.h>          
#include <I2C.h>                                                                       
#include <NavIMU.h>                    
#include <NavCompass.h>


const float R2D = 57.296;

const int SPI_CS_MPU6000 = 7;


NavIMU imu(SPI_CS_MPU6000);


//-----------------------------------------------------------------------------
//
void setup()
{
  Serial.begin(115200);

  SPI.begin();
  SPI.setClockDivider(SPI_CLOCK_DIV16);           // 1 MHz rate

  pinMode(SPI_CS_MPU6000, OUTPUT);
  digitalWrite(SPI_CS_MPU6000, HIGH);  delay(1);

  imu.init();
}


//-----------------------------------------------------------------------------
//
void loop()
{
  static unsigned long loopEpoch;
  static unsigned int  loopCount;


  if (millis() - loopEpoch < 9) {
    return;
  }
  loopEpoch = millis();


  float dt;
  float wx, wy, wz;
  float ax, ay, az;
  float mx, my, mz;
  float phi, theta, psi;


  imu.update();
  imu.get_accel(&ax, &ay, &az);
  imu.get_gyro(&wx, &wy, &wz);
  dt = imu.get_sample_time();

  ArsMahony(wx, wy, wz, ax, ay, az, dt, &phi, &theta, &psi);

  loopCount++;
  if (20 <= loopCount) {
    loopCount = 0;

    Serial.print(phi*R2D, 2);    Serial.print(", "); 
    Serial.print(theta*R2D, 2);  Serial.print(", "); 
    Serial.print(psi*R2D, 2);    Serial.println();
  }
}
