#include <SPI.h>                                                                                 
#include <NavIMU.h>                    


const float R2D = 57.296;

const int SPI_CS_MPU6000 =  7;


NavIMU imu(SPI_CS_MPU6000);



//-----------------------------------------------------------------------------
//
void setup()
{
  Serial.begin(115200);

  SPI.begin();
  SPI.setClockDivider(SPI_CLOCK_DIV16);           // 1 MHz rate

  pinMode(SPI_CS_MPU6000, OUTPUT);
  digitalWrite(SPI_CS_MPU6000, HIGH);  delay(1);

  imu.init();
}


//-----------------------------------------------------------------------------
//
void loop()
{
  static unsigned long loopEpoch;
  static unsigned int  loopCount;


  if (millis() - loopEpoch < 19) {
    return;
  }
  loopEpoch = millis();


  float ax, ay, az;
  float phi, theta;

  imu.update();
  imu.get_accel(&ax, &ay, &az);

  EulerAccel(ax, ay, &phi, &theta);

  loopCount++;
  if (5 <= loopCount) {
    Serial.print(phi*R2D, 2);    Serial.print(", "); 
    Serial.print(theta*R2D, 2);  Serial.println();
    
    loopCount = 0; 
  }
}
