#include <I2C.h>                                                                                 
#include <NavCompass.h>                    



NavCompass compass;



//-----------------------------------------------------------------------------
//
void setup()
{
  Serial.begin(115200);

  compass.init();
  compass.set_offsets(-13, -111, -42);
}


//-----------------------------------------------------------------------------
//
void loop()
{
  static unsigned long loopEpoch;
  static unsigned int  loopCount;

  float heading;
  float mx, my, mz;


  if (millis() - loopEpoch < 19) {
    return;
  }
  loopEpoch = millis();


  compass.update();
  delay(10);
  heading = compass.get_heading(0, 0);
  compass.get_magnet(&mx, &my, &mz);

  loopCount++;
  if (10 <= loopCount) {
    loopCount = 0;

    Serial.print(heading*180/3.141592);
    Serial.print(" : ");
    Serial.print(mx);  Serial.print(", ");
    Serial.print(my);  Serial.print(", ");
    Serial.print(mz);  Serial.print("\n");
  }
}