#include <SPI.h>                                                                                 
#include <NavIMU.h>                    


const int SPI_CS_MPU6000 = 7;


NavIMU imu(SPI_CS_MPU6000);



//-----------------------------------------------------------------------------
//
void setup()
{
  Serial.begin(115200);

  SPI.begin();
  SPI.setClockDivider(SPI_CLOCK_DIV16);           // 1 MHz rate

  pinMode(SPI_CS_MPU6000, OUTPUT);
  digitalWrite(SPI_CS_MPU6000, HIGH);  delay(1);

  imu.init();
}


//-----------------------------------------------------------------------------
//
void loop()
{
  static unsigned long loopEpoch;
  static unsigned int  loopCount;


  if (millis() - loopEpoch < 19) {
    return;
  }
  loopEpoch = millis();


  float dt;
  float p, q, r;
  float ax, ay, az;

  imu.update();
  imu.get_gyro(&p, &q, &r);
  imu.get_accel(&ax, &ay, &az);
  dt = imu.get_sample_time();

  loopCount++;
  if (5 <= loopCount) {
    loopCount = 0;

    Serial.print(dt, 2); Serial.print(" | ");
    Serial.print(ax, 2); Serial.print(", "); Serial.print(ay, 2); Serial.print(", "); Serial.print(az, 2); Serial.print(" | ");
    Serial.print(p, 2);  Serial.print(", "); Serial.print(q, 2);  Serial.print(", "); Serial.print(r, 2);  Serial.println();
  }
}
