#ifndef __HMC5883L_H__
#define __HMC5883L_H__


#include <Arduino.h>


class HMC5883L {
public:
	HMC5883L();

  void Init();

	void ReadRaw(int *mx, int *my, int *mz);
  
	void SetMeasurementMode(uint8_t mode);
  void SetOutputRate(uint8_t hz);
  void SetAvgSamples(uint8_t count);

	bool IsConnected();

private:
	uint8_t* ReadRegister(int address, int length);
	void     WriteRegister(int address, int value);

	float scaleFactor_;
};


#endif