#ifndef __NAVIMU_H__
#define __NAVIMU_H__


#include "MPU6000.h"


class NavIMU {
public:
  NavIMU(int cs_pin);

  void init();

  void update(void);

  void get_gyro(float *p, float *q, float *r);
  void get_accel(float *ax, float *ay, float *az);

  float get_sample_time(void)  {  return _sample_time*1e-6;  }

private: 
  MPU6000 *_imu;

  float _ax;
  float _ay;
  float _az;

  float _p;
  float _q;
  float _r;

  float _p_bias;
  float _q_bias;
  float _r_bias;

  uint32_t _sample_time;

  void calc_gyro_bias();
};


#endif
